'use strict';

// Setup variables
var gulp         = require('gulp'); // core gulp
var sass         = require('gulp-sass'); // Compile scss files
var csso         = require('gulp-csso'); // minify css
var gzip         = require('gulp-gzip'); // gzip compression
var connect      = require('gulp-connect'); // web server
var autoprefixer = require('gulp-autoprefixer');

// Web server
gulp.task('connect', function() {
  connect.server();
});

//
// Build css
//
// Compile scss files
gulp.task('sass', function () {
  return gulp.src('./src/scss/jump-start.scss')
    .pipe(sass.sync().on('error', sass.logError))
    .pipe(gulp.dest('./dist/css'));
});

// Autoprefixer
gulp.task('autoprefixer', () =>
  gulp.src('./dist/css/**/*.css')
    .pipe(autoprefixer({
      browsers: ['last 2 versions'],
      cascade: false
    }))
    .pipe(gulp.dest('./dist/css'))
);

// Minify and gzip compiled CSS
gulp.task('minify', function() {
  return gulp.src('./dist/css/**/*.css')
    .pipe(csso())
    .pipe(gulp.dest('./dist/css'))
    .pipe(gzip())
    .pipe(gulp.dest('./dist/css'));
});

// Master build task
gulp.task('build', ['sass','minify', 'autoprefixer']);
